//+------------------------------------------------------------------+
//|                                            G. Browser Trader.mq4 |
//|                                               PriceMasterPro.Com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, PriceMasterPro.Com"
#property link      "http://www.pricemasterpro.com"
#include <stdlib.mqh>

extern string info_1                 = "---------EA Settings---------";
extern double TakeProfit             = 8000;
extern double StopLoss               = 8000;  
extern double BreakEvenStop          = 500;  
extern double TrailingStop           = 500;  
extern int    slippage               = 20;   	
extern int    shift                  = 0;		
extern double Lots                   = 0.1;
extern double MaximumRisk            = 5;
extern bool   FixedLot               = true;
extern bool   alerts                 = true;
extern bool   trade                  = true;
extern int    OrderTriesNumber       =5; 
extern string    EAName              ="G Browser Trader"; 
extern int myMagic                   = 1;
extern string info1                  = "---------Indicator settings---------";
extern string TimeFrame              = "Current time frame";
extern int    Price                  = PRICE_CLOSE;
extern int    BarToCalculate         = 1;
extern int    StartAtCycle           = 1;
extern int    UseTopCycles           = 1;
extern bool   UseCosineForWaves      = true;
extern bool   UseAdditionForSteps    = false;
extern bool   UseSquaredAmp          = true;
extern int    MaxPer                 = 120;
extern int    SampleSize             = 0;
extern bool   SubtractNoise          = false;
extern bool   Interpolate            = true;
extern string info2                  ="---------Display settings---------";
extern int    WindowSizePast         = 100;
extern int    WindowSizeFuture       = 100;
extern color  FutureLineColor        = PaleVioletRed;
extern int    FutureLineStyle        = STYLE_DOT;
extern int    FutureLineDisplace     = 0;
extern bool   PredictionVisible      = false;
extern bool   ListOfCyclesVisible    = false;
extern string ListOfCyclesID         = "GortzelBrowser";
extern int    ListOfCyclesCorner     = 1;
extern color  ListOfCyclesTextColor  = DimGray;
extern color  ListOfCyclesValueColor = PaleVioletRed;
extern string info3                  = "---------Cycle list settings---------";
extern bool   UseCycleList           = false;
extern int    Cycle1                 = 1;
extern int    Cycle2                 = 1;
extern int    Cycle3                 = 1;
extern int    Cycle4                 = 1;
extern int    Cycle5                 = 1;
extern int    Offset                 = 0;
extern string info4                  = "Detrend & smooth data before cycle detection";
extern bool   DetrendSmoothData      = false;
extern int    FilterPeriod           = 34;
extern int    FilterPeriod1          = 69;
extern string info5                  = "Use cycle strength to sort cycles";
extern bool   UseCycleStrength       = false;

bool buysig,sellsig,closebuy,closesell; int lastsig,tries,at,at2;


void start()  {

   //---- check for history and trading
  Comment("Balance = ",AccountBalance()," ; Profit = ", AccountProfit());

   if(Bars<100 || IsTradeAllowed()==false) return;

   //---- check for signals
   CheckForSignals();

   if (trade || IsTesting()) {
      if (CalculateCurrentOrders(Symbol())==0)     //---- calculate open orders by current symbol
         CheckForOpen();
      else {
         CheckForClose();
         BreakEvenStop();
         TrailStop();
      }
   }
        
}

double LotsRisk(int StopLoss)  { 
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/StopLoss,1);
   else
      lot=Lots;
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int ord;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==symbol && OrderMagicNumber()==myMagic) ord++;
     }
//---- return orders volume
   return(ord);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {
      
      //indicators variables
      double Gnow = iCustom(NULL,0 ,"Goertzel browser 5.3","","calculateValue",Price,BarToCalculate,StartAtCycle,UseTopCycles,UseCosineForWaves,UseAdditionForSteps, UseSquaredAmp,
                                    MaxPer,SampleSize,SubtractNoise,Interpolate,"",WindowSizePast,WindowSizeFuture,FutureLineColor,FutureLineStyle,Period()*60,PredictionVisible,
                                    ListOfCyclesVisible,ListOfCyclesID,ListOfCyclesCorner,ListOfCyclesTextColor,ListOfCyclesValueColor,"",UseCycleList,Cycle1,Cycle2,Cycle3,Cycle4,Cycle5,Offset,
                                    "",DetrendSmoothData,FilterPeriod,FilterPeriod1,"",UseCycleStrength,0,shift);
                           
      double Gbefore = iCustom(NULL,0 ,"Goertzel browser 5.3","","calculateValue",Price,BarToCalculate,StartAtCycle,UseTopCycles,UseCosineForWaves,UseAdditionForSteps, UseSquaredAmp,
                                    MaxPer,SampleSize,SubtractNoise,Interpolate,"",WindowSizePast,WindowSizeFuture,FutureLineColor,FutureLineStyle,Period()*60,PredictionVisible,
                                    ListOfCyclesVisible,ListOfCyclesID,ListOfCyclesCorner,ListOfCyclesTextColor,ListOfCyclesValueColor,"",UseCycleList,Cycle1,Cycle2,Cycle3,Cycle4,Cycle5,Offset,
                                    "",DetrendSmoothData,FilterPeriod,FilterPeriod1,"",UseCycleStrength,0,shift+1);
                                    

                            
      //Print("\nGnow= ",Gnow,
              //"\nGbefore= ",Gbefore);     
   
      buysig=false;
      sellsig=false;
      //long entry signal condition
      if (Gnow>Gbefore) {
          buysig=true;
          if (alerts && at!=Time[0]) {
            Alert(Symbol()+Period()+" : long signal @ " + DoubleToStr(Bid,Digits));
            SendMail("",Symbol()+Period()+" : long signal @ " + DoubleToStr(Bid,Digits));
            at=Time[0];
          }
      }
      //short entry signal
      if (Gnow<Gbefore) {
          sellsig=true;
          if (alerts && at!=Time[0]) {
            Alert(Symbol()+Period()+" : short signal @ " + DoubleToStr(Bid,Digits));
            SendMail("",Symbol()+Period()+" : short signal @ " + DoubleToStr(Bid,Digits));
            at=Time[0];
          }
      }

      closebuy=false;
      closesell=false;
      //long exit signal
      if (Gnow<Gbefore) {
          closebuy=true;
          if (alerts && at2!=Time[0]) {
            Alert(Symbol()+Period()+" : long exit signal @ " + DoubleToStr(Bid,Digits));
            SendMail("",Symbol()+Period()+" : long exit signal @ " + DoubleToStr(Bid,Digits));
            at2=Time[0];
          }
      }
      //short exit signal
      if (Gnow>Gbefore){
          closesell=true;
          if (alerts && at2!=Time[0]) {
            Alert(Symbol()+Period()+" : short exit signal @ " + DoubleToStr(Bid,Digits));
            SendMail("",Symbol()+Period()+" : short exit signal @ " + DoubleToStr(Bid,Digits));
            at2=Time[0];
          }
      }
}

void CheckForOpen() {
   int    res,tr;
//---- sell conditions
   if(sellsig && lastsig!=-1)  {
	   res=0;
	   tries=0;
		while (res<=0 && tries<OrderTriesNumber) {
          tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(5000); }
		    RefreshRates();
          res=OrderSend(Symbol(),OP_SELL,LotsRisk(StopLoss),Bid,slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,EAName,myMagic,0,Red);
		    if (res<0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		    tries++;
		}
      lastsig=-1;
      return;
   }
//---- buy conditions
   if(buysig && lastsig!=1)  {
	   res=0;
	   tries=0;
		while (res<=0 && tries<OrderTriesNumber) {
          tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(5000); }
		    RefreshRates();
          res=OrderSend(Symbol(),OP_BUY,LotsRisk(StopLoss),Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,EAName,myMagic,0,Blue);
          tries++;
		}
      lastsig = 1;
      return;
   }
}
  
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
   bool bres; int tr;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
      if(OrderMagicNumber()!=myMagic || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if (closebuy) {
            bres=false;
	         tries=0;
		      while (!bres && tries<OrderTriesNumber) {
               tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(5000); }
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White);
               Sleep(3000);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
		   }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if (closesell) {
            bres=false;
	         tries=0;
		      while (!bres && tries<OrderTriesNumber) {
               tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(5000); }
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),Ask,slippage,White);
               Sleep(3000);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
		   }
         break;
        }
     }
}


void TrailStop() {
   bool bres;
   double StopLoss;
   if ( TrailingStop > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+TrailingStop*Point )  return;
            StopLoss = Bid-TrailingStop*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-TrailingStop*Point )  return;
            StopLoss = Ask+TrailingStop*Point;
            if ( StopLoss < OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}

void BreakEvenStop() {
   bool bres;
   double StopLoss;
   if ( BreakEvenStop > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BreakEvenStop*Point )  return;
            StopLoss = OrderOpenPrice();
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BreakEvenStop*Point )  return;
            StopLoss = OrderOpenPrice();
            if ( StopLoss < OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}




